<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArtigoFornecedorERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArtigoFornecedorERP
 * @subpackage Arrays
 */
class ArrayOfArtigoFornecedorERP extends AbstractStructArrayBase
{
    /**
     * The ArtigoFornecedorERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ArtigoFornecedorERP[]
     */
    public $ArtigoFornecedorERP;
    /**
     * Constructor method for ArrayOfArtigoFornecedorERP
     * @uses ArrayOfArtigoFornecedorERP::setArtigoFornecedorERP()
     * @param \StructType\ArtigoFornecedorERP[] $artigoFornecedorERP
     */
    public function __construct(array $artigoFornecedorERP = array())
    {
        $this
            ->setArtigoFornecedorERP($artigoFornecedorERP);
    }
    /**
     * Get ArtigoFornecedorERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ArtigoFornecedorERP[]|null
     */
    public function getArtigoFornecedorERP()
    {
        return isset($this->ArtigoFornecedorERP) ? $this->ArtigoFornecedorERP : null;
    }
    /**
     * Set ArtigoFornecedorERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ArtigoFornecedorERP[] $artigoFornecedorERP
     * @return \ArrayType\ArrayOfArtigoFornecedorERP
     */
    public function setArtigoFornecedorERP(array $artigoFornecedorERP = array())
    {
        foreach ($artigoFornecedorERP as $arrayOfArtigoFornecedorERPArtigoFornecedorERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfArtigoFornecedorERPArtigoFornecedorERPItem instanceof \StructType\ArtigoFornecedorERP) {
                throw new \InvalidArgumentException(sprintf('The ArtigoFornecedorERP property can only contain items of \StructType\ArtigoFornecedorERP, "%s" given', is_object($arrayOfArtigoFornecedorERPArtigoFornecedorERPItem) ? get_class($arrayOfArtigoFornecedorERPArtigoFornecedorERPItem) : gettype($arrayOfArtigoFornecedorERPArtigoFornecedorERPItem)), __LINE__);
            }
        }
        if (is_null($artigoFornecedorERP) || (is_array($artigoFornecedorERP) && empty($artigoFornecedorERP))) {
            unset($this->ArtigoFornecedorERP);
        } else {
            $this->ArtigoFornecedorERP = $artigoFornecedorERP;
        }
        return $this;
    }
    /**
     * Add item to ArtigoFornecedorERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ArtigoFornecedorERP $item
     * @return \ArrayType\ArrayOfArtigoFornecedorERP
     */
    public function addToArtigoFornecedorERP(\StructType\ArtigoFornecedorERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ArtigoFornecedorERP) {
            throw new \InvalidArgumentException(sprintf('The ArtigoFornecedorERP property can only contain items of \StructType\ArtigoFornecedorERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArtigoFornecedorERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ArtigoFornecedorERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ArtigoFornecedorERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ArtigoFornecedorERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ArtigoFornecedorERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ArtigoFornecedorERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArtigoFornecedorERP
     */
    public function getAttributeName()
    {
        return 'ArtigoFornecedorERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfArtigoFornecedorERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
